/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package du3reseni;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

/**
 *
 * @author balikm1
 */
public class MainTest {
    
    public MainTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }
    
    /**
     * Test of getters, setters, toString.
     */
    @Test
    public void testGetSetConstructorToString() {
        String strValue1 = "stringValue1";
        String strValue2 = "stringValue2";
        String strValue3 = "stringValue3";
        String strValue4 = "stringValue4";
        String strValue5 = "stringValue5";
        int intValue1 = 9632;
        int intValue2 = 6381;
        Osoba instance = new Osoba(strValue1, strValue2, strValue3, intValue1, intValue2, strValue4, strValue5);
        assertEquals("Neodpovida jmeno", strValue1, instance.getJmeno());
        assertEquals("Neodpovida prijmeni", strValue2, instance.getPrijmeni());
        assertEquals("Neodpovida ulice", strValue3, instance.getUlice());
        assertEquals("Neodpovida mesto", strValue4, instance.getMesto());
        assertEquals("Neodpovida email", strValue5, instance.getEmail());
        assertEquals("Neodpovida cislo popisne", intValue1, instance.getCisloPopisne());
        assertEquals("Neodpovida psc", intValue2, instance.getPsc());
        
        String toStringValue = "\nJmeno : " + strValue1
                + "\nPrijmeni : " + strValue2
                + "\nUlice : " + strValue3 + " " + Integer.toString(intValue1)
                + "\nMesto : " + strValue4
                + "\nPSC : " + Integer.toString(intValue2)
                + "\nEmail : " + strValue5 + "\n";
        assertEquals("Chybny vystup toString", toStringValue , instance.toString());
        
        instance = new Osoba("", "", "", 0, 0, "", "");
        instance.setJmeno(strValue1);
        instance.setPrijmeni(strValue2);
        instance.setUlice(strValue3);
        instance.setMesto(strValue4);
        instance.setEmail(strValue5);
        instance.setCisloPopisne(intValue1);
        instance.setPsc(intValue2);
        assertEquals("Neodpovida jmeno", strValue1, instance.getJmeno());
        assertEquals("Neodpovida prijmeni", strValue2, instance.getPrijmeni());
        assertEquals("Neodpovida ulice", strValue3, instance.getUlice());
        assertEquals("Neodpovida mesto", strValue4, instance.getMesto());
        assertEquals("Neodpovida email", strValue5, instance.getEmail());
        assertEquals("Neodpovida cislo popisne", intValue1, instance.getCisloPopisne());
        assertEquals("Neodpovida psc", intValue2, instance.getPsc());
    }

    /**
     * Test of add, remove.
     */
    @Test
    public void testAddRemoveCountVratOsobuIndexOf() {
        Kartoteka k = new Kartoteka();
        
        String strValue1 = "1stringValue1";
        String strValue2 = "1stringValue2";
        String strValue3 = "1stringValue3";
        String strValue4 = "1stringValue4";
        String strValue5 = "1stringValue5";
        int intValue1 = 9632;
        int intValue2 = 6381;
        Osoba instance1 = new Osoba(strValue1, strValue2, strValue3, intValue1, intValue2, strValue4, strValue5);
        
        String strValue21 = "2stringValue1";
        String strValue22 = "2stringValue2";
        String strValue23 = "2stringValue3";
        String strValue24 = "2stringValue4";
        String strValue25 = "2stringValue5";
        int intValue21 = 29632;
        int intValue22 = 26381;
        Osoba instance2 = new Osoba(strValue21, strValue22, strValue23, intValue21, intValue22, strValue24, strValue25);
        
        assertEquals(0, k.count());
        k.add(instance1);
        assertEquals("Neodpovida pocet po 1. vlozeni", 1, k.count());
        k.add(instance1);
        assertEquals("Neodpovida pocet po opakovanem vlozeni", 1, k.count());
        k.add(instance2);
        assertEquals("Neodpovida pocet po dalsim vlozeni", 2, k.count());
        k.remove(instance1);
        assertEquals("Neodpovida pocet po odebrani", 1, k.count());
        assertEquals("Po odebrani nenalezena spravna osoba pomoci vratOsobu a indexOf", instance2, k.vratOsobu(k.indexOf(instance2)));
    }
    
    /**
     * Test of vrat, index, toString, equals, hashcode.
     */
    @Test
    public void testVypisuEqualsHashCodeVlozeniVratOsobuAindexOf() {
        Kartoteka k = new Kartoteka();
        assertEquals("Chybny vystup toString", "Prazdna kartoteka", k.toString());
        
        String strValue1 = "1stringValue1";
        String strValue2 = "1stringValue2";
        String strValue3 = "1stringValue3";
        String strValue4 = "1stringValue4";
        String strValue5 = "1stringValue5";
        int intValue1 = 9632;
        int intValue2 = 6381;
        Osoba instance1 = new Osoba(strValue1, strValue2, strValue3, intValue1, intValue2, strValue4, strValue5);
        
        String strValue21 = "2stringValue1";
        String strValue22 = "2stringValue2";
        String strValue23 = "2stringValue3";
        String strValue24 = "2stringValue4";
        String strValue25 = "2stringValue5";
        int intValue21 = 29632;
        int intValue22 = 26381;
        Osoba instance2 = new Osoba(strValue21, strValue22, strValue23, intValue21, intValue22, strValue24, strValue25);
        
        k.add(instance1);
        k.add(instance2);
        assertEquals("Osoba nalezena pomoci indexOf / vratOsobu neni spravna nebo nefunguje porovnani.", instance2, k.vratOsobu(k.indexOf(instance2)));
        assertTrue("Osoba nalezena pomoci indexOf / vratOsobu neni spravna nebo nefunguje porovnani.", instance2.equals(k.vratOsobu(k.indexOf(instance2))));
        assertTrue("Chybny hashCode", instance2.hashCode() == k.vratOsobu(k.indexOf(instance2)).hashCode());
    }
    
    /**
     * Test of search.
     */
    @Test
    public void testVyhledaniPodleJmenaPrijmeniNeboOboje() {
        Kartoteka k = new Kartoteka();
        
        String strValue1 = "1stringValue1";
        String strValue2 = "1stringValue2";
        String strValue3 = "1stringValue3";
        String strValue4 = "1stringValue4";
        String strValue5 = "1stringValue5";
        int intValue1 = 9632;
        int intValue2 = 6381;
        Osoba instance1 = new Osoba(strValue1, strValue2, strValue3, intValue1, intValue2, strValue4, strValue5);
        
        String strValue21 = "2stringValue1";
        String strValue22 = "2stringValue2";
        String strValue23 = "2stringValue3";
        String strValue24 = "2stringValue4";
        String strValue25 = "2stringValue5";
        int intValue21 = 29632;
        int intValue22 = 26381;
        Osoba instance2 = new Osoba(strValue21, strValue22, strValue23, intValue21, intValue22, strValue24, strValue25);
        
        String strValue31 = "3stringValue1";
        String strValue32 = "2stringValue2";
        String strValue33 = "2stringValue3";
        String strValue34 = "2stringValue4";
        String strValue35 = "2stringValue5";
        int intValue31 = 29632;
        int intValue32 = 26381;
        Osoba instance3 = new Osoba(strValue31, strValue32, strValue33, intValue31, intValue32, strValue34, strValue35);
        
        String strValue41 = "2stringValue1";
        String strValue42 = "4stringValue2";
        String strValue43 = "2stringValue3";
        String strValue44 = "2stringValue4";
        String strValue45 = "2stringValue5";
        int intValue41 = 29632;
        int intValue42 = 26381;
        Osoba instance4 = new Osoba(strValue41, strValue42, strValue43, intValue41, intValue42, strValue44, strValue45);
        
        k.add(instance1);
        k.add(instance2);
        k.add(instance3);
        k.add(instance4);
        
        Kartoteka res1 = k.vyhledejOsobyPodleJmena("2stringValue1", null);
        assertEquals("Pocet osob nalezenych podle jmena neodpovida.", 2, res1.count());
        Kartoteka res2 = k.vyhledejOsobyPodleJmena(null, "2stringValue2");
        assertEquals("Pocet osob nalezenych podle prijmeni neodpovida.", 2, res2.count());
        Kartoteka res3 = k.vyhledejOsobyPodleJmena("2stringValue1", "4stringValue2");
        assertEquals("Pocet osob nalezenych podle jmena a prijmeni neodpovida.", 1, res3.count());
        assertEquals("Osoba nalezena pomoci indexOf / vratOsobu neni spravna nebo nefunguje porovnani.", instance4, res3.vratOsobu(res3.indexOf(instance4)));
    }
    
    /**
     * Test of inc array.
     */
    @Test
    public void testInkrementacePoleKonstantyAmodifikatoru() {
        Kartoteka k = new Kartoteka();
        
        String strValue21 = "2stringValue1";
        String strValue22 = "2stringValue2";
        String strValue23 = "2stringValue3";
        String strValue24 = "2stringValue4";
        String strValue25 = "2stringValue5";
        int intValue21 = 29632;
        int intValue22 = 26381;
        
        for (int i=0; i<10000; i++) {
            k.add(new Osoba(strValue21+Integer.toString(i), strValue22, strValue23, intValue21, intValue22, strValue24, strValue25));
            Class theClass = Kartoteka.class;
            Field f = null;
            Field g = null;
            try {
                f = theClass.getDeclaredField("poleOsob");
                g = theClass.getDeclaredField("POLE_INC");
            } catch (Exception e) {}
            assertNotNull("Nenalezeno poleOsob", f);
            assertNotNull("Nenalezena konstanta POLE_INC", g);
            assertTrue("Chybne modifikatory poleOsob", (f.getModifiers() & Modifier.PRIVATE) == Modifier.PRIVATE);
            assertTrue("Chybne modifikatory POLE_INC", (g.getModifiers() & Modifier.PRIVATE) == Modifier.PRIVATE);
            assertTrue("Chybne modifikatory POLE_INC", (g.getModifiers() & Modifier.STATIC) == Modifier.STATIC);
            assertTrue("Chybne modifikatory POLE_INC", (g.getModifiers() & Modifier.FINAL) == Modifier.FINAL);
            f.setAccessible(true);
            g.setAccessible(true);
            Osoba[] poleOsob = null;
            int poleInc = 0;
            try {
                assertTrue("Chybny typ poleOsob", f.get(k).getClass().isArray());
                assertTrue("Chybny typ POLE_INC", g.get(k).getClass() == Integer.class);
                poleOsob = (Osoba[])f.get(k);
                poleInc = (Integer)g.get(k);
            } catch (Exception e) { }
            assertNotNull("Nenalezena hodnota poleOsob", poleOsob);
            assertEquals("Chybna velikost poleOsob", i-(i%poleInc)+ poleInc, poleOsob.length);
        }
    }
}
